#include "gloobus-preview-interface-image.h"

// ========================= DESTRUCTOR ================================== //
iImage::~iImage()
{
	gtk_widget_destroy	(m_image);
	gtk_widget_destroy	(m_image_container);
	gdk_pixbuf_unref 	(m_pixbuf);
}
//=========================  END ========================================= //
void iImage::end()
{

}
// ========================= CONSTRUCTOR ================================= //
void iImage::load()
{
	g_debug("\nLoading Image...\n");
	m_pixbuf = scale_pixbuf(get_pixbuf(), get_screen_width()-150,get_screen_height()-150);
};

// =========================== GET SIZE (W)================================= //
int  iImage::get_width()
{
	//g_debug("Width: %d\n", gdk_pixbuf_get_width(m_pixbuf));
	if(gdk_pixbuf_get_width(m_pixbuf) < 300)
	{
	 	return 300;
	}
	return gdk_pixbuf_get_width(m_pixbuf);
};

// =========================== GET SIZE (H)================================= //
int  iImage::get_height()
{
	//g_debug("Height: %d\n",gdk_pixbuf_get_height(m_pixbuf));
	if(gdk_pixbuf_get_height(m_pixbuf) < 300)
	{
		return 300;
	}
	return gdk_pixbuf_get_height(m_pixbuf) + 15;		//FIXME: Why do I have to add this +20?
};

// =========================== DRAW IMAGE ================================= //
void iImage::draw_image(GtkContainer * container)
{

	m_image 			= gtk_image_new_from_pixbuf (m_pixbuf);
	m_image_container	= gtk_fixed_new ();
	int x = SHADOW_WIDTH;			//Default values are at top left
	int y = HEADER_HEIGHT + SHADOW_WIDTH;			//and 20 from top (For the header)

	if(gdk_pixbuf_get_width(m_pixbuf) < 300)		//Minum width
	{
		x = (150 + SHADOW_WIDTH ) - gdk_pixbuf_get_width(m_pixbuf)/2;
	}
	if(gdk_pixbuf_get_height(m_pixbuf) < 300)		//Minium height
	{
		y = (150 + SHADOW_WIDTH + HEADER_HEIGHT) - gdk_pixbuf_get_height(m_pixbuf)/2;
	}


	gtk_fixed_put 	  (GTK_FIXED(m_image_container),m_image,x,y);
	gtk_container_add (GTK_CONTAINER(container),m_image_container);
	gtk_widget_show   (m_image_container);
	gtk_widget_show   (m_image);

};

// ========================= DRAW IMAGE INFO ===================== //
void iImage::draw_file_info(GtkContainer * container)
{
	draw_properties ( container, get_file_info_string(), 25 + SHADOW_WIDTH, get_height() + SHADOW_WIDTH + HEADER_HEIGHT - 5 );
}

// ========================= DRAW ===================== //
// Virtual function that draws what plugin wants
void iImage::draw( GtkContainer * container )
{
	draw_image		( GTK_CONTAINER(container ));
	draw_file_info	( GTK_CONTAINER(container ));
}
