#include "gloobus-preview-interface-list.h"

// ========================= DESTRUCTOR =================================== //
iList::~iList()
{
	//gtk_widget_destroy  ( m_image );
	//gtk_widget_destroy  ( m_image_container );
	gdk_pixbuf_unref 	  ( m_pixbuf);
}
//============================= END =========================================== //
void iList::end()
{

}
// ========================= CONSTRUCTOR ================================= //
void iList::load()
{
	g_debug("\nLoading iList...\n");
	m_pixbuf 	 = scale_pixbuf(get_pixbuf(),ICON_SIZE,ICON_SIZE);
	m_reflection = pixbuf_reflection(m_pixbuf);		//Creates the reflection Pixbuf
	
};

// =========================== GET SIZE (W)================================= //
int  iList::get_width()
{
	 	return 500;

};

// =========================== GET SIZE (H)================================= //
int  iList::get_height()
{
	
		return 500;
	
};

// =========================== DRAW IMAGE ================================= //
void iList::draw_list(GtkContainer * container)
{

	GtkWidget *image 				= gtk_image_new_from_pixbuf (m_pixbuf);
	GtkWidget *image_container		= gtk_fixed_new ();
	GtkWidget *reflection  			= gtk_image_new_from_pixbuf (m_reflection);
	GtkWidget *reflection_container	= gtk_fixed_new ();

	int x = SHADOW_WIDTH;							//Default values are at top left
	int y = HEADER_HEIGHT + SHADOW_WIDTH;			//and 20 from top (For the header)

	if(gdk_pixbuf_get_width(m_pixbuf) < 300)		//Minum width
	{
		x = 150-gdk_pixbuf_get_width(m_pixbuf)/2;
	}
	if(gdk_pixbuf_get_height(m_pixbuf) < 300)		//Minium height
	{
		y = 150-gdk_pixbuf_get_height(m_pixbuf)/2;
	}


	gtk_fixed_put 	  	(GTK_FIXED(image_container),image,50+SHADOW_WIDTH, 50 + SHADOW_WIDTH + HEADER_HEIGHT);
	gtk_fixed_put 	  	(GTK_FIXED(reflection_container),reflection,50+SHADOW_WIDTH, 50 + SHADOW_WIDTH + HEADER_HEIGHT + gdk_pixbuf_get_height(m_pixbuf));
	gtk_container_add 	(GTK_CONTAINER(container),image_container);
	gtk_container_add 	(GTK_CONTAINER(container),reflection_container);
	gtk_widget_show   	(image_container);
	gtk_widget_show   	(image);
	gtk_widget_show	 	(reflection_container);
	gtk_widget_show	 	(reflection);
	
	//======================================== FILE INFO ====================================//	
	
	iList::draw_file_info(container);
	
	//=========================================== LIST ======================================//
	
	GtkWidget *scwin = gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy 		( GTK_SCROLLED_WINDOW(scwin) , GTK_POLICY_AUTOMATIC ,GTK_POLICY_AUTOMATIC );
	gtk_scrolled_window_set_shadow_type ( GTK_SCROLLED_WINDOW(scwin),  GTK_SHADOW_IN);
	
	int n = get_n_items();

  	// =================== Create COLUMNS ======================== //
  	GtkTreeViewColumn   *col;
  	GtkCellRenderer     *renderer;
	GtkWidget *treeView = gtk_tree_view_new				();
					      gtk_tree_view_set_rules_hint	(GTK_TREE_VIEW(treeView), true);					//Diferent color for each row
					      
  	for(int k=0; k< get_n_columns(); k++)
  	{
	  	col 	 =	gtk_tree_view_column_new		( );
	  				gtk_tree_view_column_set_title	( col, get_column_title(k).c_str());
					gtk_tree_view_append_column		( GTK_TREE_VIEW(treeView), col);	  /* pack tree view column into tree view */
		renderer = 	gtk_cell_renderer_text_new		( );
					gtk_tree_view_column_pack_start	( col, renderer, TRUE);				  /* pack cell renderer into tree view column */
					gtk_tree_view_column_add_attribute(col, renderer, "markup", k);		  /* Add model column 0 to text*/
					gtk_tree_view_column_set_sort_column_id(col,k);						  /* Sortable */
	}
	
	//================= Create model and fill it =================== //
	GtkListStore * listStore =  get_list_store();				//Plugin creates its own ListStoreModel
	GtkTreeIter   iter;
	
	for(int l = 0; l<n; l++)
	{
		gtk_list_store_append	(listStore, &iter);
		for ( int j = 0; j<get_n_columns(); j++)
		{
			gtk_list_store_set 		(listStore, &iter, j, get_item(l,j).c_str(),  -1);
		}
	
	}


	gtk_tree_view_set_model(GTK_TREE_VIEW(treeView),GTK_TREE_MODEL(listStore));
	

	gtk_scrolled_window_add_with_viewport	( GTK_SCROLLED_WINDOW( scwin ), treeView);						//NEW WAY
	gtk_widget_set_uposition	  	( scwin , 25 + SHADOW_WIDTH, 260 + SHADOW_WIDTH + HEADER_HEIGHT );
    gtk_widget_set_usize			( scwin , 450, 250);
    gtk_widget_show_all				( scwin  );  
  	gtk_container_add			   	( GTK_CONTAINER(container), scwin );
};

// ========================= DRAW IMAGE INFO ===================== //
void iList::draw_file_info(GtkContainer * container)
{
	draw_properties ( container, get_file_info_string(), 285 + SHADOW_WIDTH,80 + SHADOW_WIDTH);
}

// ========================= DRAW ===================== //
// Virtual function that draws what plugin wants
void iList::draw( GtkContainer * container )
{
	draw_list		( GTK_CONTAINER(container ));
	draw_file_info	( GTK_CONTAINER(container ));
}
