#include "plugin-compressed.h"

// ========================== GET PIXBUF ======================= //
GdkPixbuf * iCompressed::get_pixbuf ()
{
	return get_icon();
};

// ===================== GET FOLDER FILES ======================= //
int iCompressed::get_folder_files ()
{
	gchar 		* std_out;
	gchar		* quoted_file;
	gchar 		**cbr_files;
	gboolean 	success;
	
	
	//1.Depending on mime define list_command and extract_command
	//g_debug("PLUGIN: Compressed file type: %s\n",get_safe_type(false).c_str());
	
	quoted_file = g_shell_quote (m_filename.c_str()); 
	
	if(get_safe_type(false) == "application/rar")				m_list_command	  = g_strdup_printf ("unrar vb -c- -- %s", quoted_file); 
	if(get_safe_type(false) == "application/zip")				m_list_command	  = g_strdup_printf ("zipinfo -1 -- %s", quoted_file); 
	if(get_safe_type(false) == "application/x-compressed-tar")	m_list_command	  = g_strdup_printf ("tar -tf %s", quoted_file); 
	
	//2.Get names of the files in the zip/rar sorted! 
	success = g_spawn_command_line_sync (m_list_command, &std_out, NULL, NULL, NULL);
 	g_free (m_list_command);
 	
	if(success)
	{
		cbr_files = g_strsplit (std_out, "\n", 0);
		g_free (std_out); 
	
		for (int i = 0; cbr_files[i] != NULL; i++) 
		{ 
				//g_print("PLUGIN: File: %s\n",cbr_files[i]);
				m_files.push_back(g_strdup (cbr_files[i]));
		}
	}
	else
	{
		g_error("PLUGIN: Couldn't list the files\n");
		exit(-1);
	}

	//3.Get size
	//calculate_size();
}

//========================= GET LIST STORE ================== //
GtkListStore*  	iCompressed::get_list_store		( void )
{
	return gtk_list_store_new  (1,G_TYPE_STRING);
}
//============================ GET N ITEMS ================== //
int iCompressed::get_n_items ( ) 
{
	get_folder_files();
	return m_files.size() - 1;
}
//============================ GET ITEM ================== //
string iCompressed::get_item (int i, int j)
{
	return m_files[i];
}
//============================ GET N COLUMNS ================== //
int iCompressed::get_n_columns ( void )
{
	return 1;
}
//========================= GET COLUMN TITLE ================== //
string	iCompressed::get_column_title 	( int i )
{
	if (i==0) return _("Filename");
		
	g_error("No more than 1 columns");
}
			  	
