#include "plugin-folder.h"

// ========================== GET PIXBUF ======================= //
GdkPixbuf * iFolder::get_pixbuf ()
{
	string path = m_filename + "/cover.jpg";
	GdkPixbuf *temp = gdk_pixbuf_new_from_file (path.c_str(),NULL);
	if(temp == NULL)
	{
		g_warning(_("No JPG Cover image for this folder\n"));
		path = m_filename + "/cover.png";
		GdkPixbuf *temp = gdk_pixbuf_new_from_file (path.c_str(),NULL);
		if(temp == NULL)
		{
			g_warning(_("No PNG Cover image for this folder\n"));
			return get_icon();
		}
		else
		{
			return temp;
		}
	}
	else
	{
		return temp;
	}

};

// ===================== GET FOLDER FILES ======================= //
int iFolder::get_folder_files (string dir, vector<string> &files)
{
    DIR *dp;
    struct dirent *dirp;
    if((dp  = opendir(dir.c_str())) == NULL) {
        cout << "Error(" << errno << ") opening " << dir << endl;
        return errno;
    }

    while ((dirp = readdir(dp)) != NULL) 
    {

		if(string(dirp->d_name) != "." && string(dirp->d_name) != "..")  
		{
        	files.push_back 	(string(dirp->d_name));
        	m_size.push_back  	(get_file_size(m_filename + "/"+files[files.size()-1]));
		}
    }
    
    sort( files.begin(), files.end() );
    closedir(dp);
    return 0;
}

//========================= GET LIST STORE ================== //
GtkListStore*  	iFolder::get_list_store		( void )
{
	return gtk_list_store_new  (2,G_TYPE_STRING,G_TYPE_STRING);
}
//============================ GET N ITEMS ================== //
int iFolder::get_n_items ( ) 
{
	get_folder_files(m_filename, m_files);
	return m_files.size();
}
//============================ GET ITEM ================== //
string iFolder::get_item (int i, int j)
{
	if(j==0) return m_files[i];
	else	 return m_size[i];
}
//============================ GET N COLUMNS ================== //
int iFolder::get_n_columns ( void )
{
	return 2;
}
//========================= GET COLUMN TITLE ================== //
string	iFolder::get_column_title 	( int i )
{
	if (i==0) return _("Filename");
	if (i==1) return _("Size");
	
	g_error("No more than 2 columns");
}
			  	
